/* 
   BASSCD 2.3, Aurora include file, By KrYpT 2006
   Requires BASS 2.3 - available from www.un4seen.com
   See the BASSCD.CHM file for more complete documentation 
*/

#ifndef BASSCD_H
#define BASSCD_H

#use "basscd.lib"

// Additional error codes returned by BASS_ErrorGetCode
#define BASS_ERROR_NOCD		12	// no CD in drive
#define BASS_ERROR_CDTRACK	13	// invalid track number
#define BASS_ERROR_NOTAUDIO	17	// not an audio track

// Additional config options
#define BASS_CONFIG_CD_FREEOLD		0x10200
#define BASS_CONFIG_CD_RETRY		0x10201
#define BASS_CONFIG_CD_AUTOSPEED	0x10202
#define BASS_CONFIG_CD_SKIPERROR	0x10203

struct BASS_CD_INFO
{
	UNSIGNED INT rwflags;	// read/write capability flags
	INT canopen;	        // BASS_CD_DOOR_OPEN/CLOSE is supported?
	INT canlock;	        // BASS_CD_DOOR_LOCK/UNLOCK is supported?
	UNSIGNED INT maxspeed;	// max read speed (KB/s)
	UNSIGNED INT cache;	    // cache size (KB)
	INT cdtext;	            // can read CD-TEXT
}

// "rwflag" read capability flags
#define BASS_CD_RWFLAG_READCDR		 1
#define BASS_CD_RWFLAG_READCDRW		 2
#define BASS_CD_RWFLAG_READCDRW2	 4
#define BASS_CD_RWFLAG_READDVD		 8
#define BASS_CD_RWFLAG_READDVDR		 16
#define BASS_CD_RWFLAG_READDVDRAM	 32
#define BASS_CD_RWFLAG_READANALOG	 0x10000
#define BASS_CD_RWFLAG_READM2F1		 0x100000
#define BASS_CD_RWFLAG_READM2F2		 0x200000
#define BASS_CD_RWFLAG_READMULTI	 0x400000
#define BASS_CD_RWFLAG_READCDDA		 0x1000000
#define BASS_CD_RWFLAG_READCDDASIA	 0x2000000
#define BASS_CD_RWFLAG_READSUBCHAN	 0x4000000
#define BASS_CD_RWFLAG_READSUBCHANDI 0x8000000
#define BASS_CD_RWFLAG_READISRC		 0x20000000
#define BASS_CD_RWFLAG_READUPC		 0x40000000

// additional BASS_CD_StreamCreate/File flags
#define BASS_CD_SUBCHANNEL		0x200
#define BASS_CD_SUBCHANNEL_NOHW	0x400

// additional CD sync type
#define BASS_SYNC_CD_ERROR		1000
#define BASS_SYNC_CD_SPEED		1002

// BASS_CD_Door actions
#define BASS_CD_DOOR_CLOSE		0
#define BASS_CD_DOOR_OPEN		1
#define BASS_CD_DOOR_LOCK		2
#define BASS_CD_DOOR_UNLOCK		3

// BASS_CD_GetID flags
#define BASS_CDID_UPC		  1
#define BASS_CDID_CDDB		  2
#define BASS_CDID_CDDB2		  3
#define BASS_CDID_TEXT		  4
#define BASS_CDID_CDPLAYER	  5
#define BASS_CDID_MUSICBRAINZ 6
#define BASS_CDID_ISRC		  0x100 // + track #

// BASS_CHANNELINFO type
#define BASS_CTYPE_STREAM_CD	0x10200


Declare Import, BASS_CD_GetDriveDescription(INT drive),INT;
Declare Import, BASS_CD_GetDriveLetter(INT drive),INT;
Declare Import, BASS_CD_GetInfo(INT drive, BASS_CD_INFO info ByRef),INT;
Declare Import, BASS_CD_Door(INT drive, INT action),INT;
Declare Import, BASS_CD_DoorIsLocked(INT drive),INT;
Declare Import, BASS_CD_DoorIsOpen(INT drive),INT;
Declare Import, BASS_CD_IsReady(INT drive),INT;
Declare Import, BASS_CD_GetTracks(INT drive),INT;
Declare Import, BASS_CD_GetTrackLength(INT drive, INT track),INT;
Declare Import, BASS_CD_GetTrackPregap(INT drive, INT track),INT;
Declare Import, BASS_CD_GetID (INT drive, INT id),INT;
Declare Import, BASS_CD_GetSpeed(INT drive),INT;
Declare Import, BASS_CD_SetSpeed(INT drive, INT speed),INT;
Declare Import, BASS_CD_Release(INT drive),INT;

Declare Import, BASS_CD_StreamCreate(INT drive, INT track, INT flags),INT;
Declare Import, BASS_CD_StreamCreateFile(String f, INT flags),INT;
Declare Import, BASS_CD_StreamGetTrack(INT handle),INT;
Declare Import, BASS_CD_StreamSetTrack(INT handleg, INT track),INT;

Declare Import, BASS_CD_Analog_Play(INT drive, INT track, INT pos),INT;
Declare Import, BASS_CD_Analog_PlayFile(String f, INT pos),INT;
Declare Import, BASS_CD_Analog_Stop(INT drive),INT;
Declare Import, BASS_CD_Analog_IsActive(INT drive),INT;
Declare Import, BASS_CD_Analog_GetPosition(INT drive),INT;


#endif
