/* 
BASSWMA 2.3 Aurora include file, By KrYpT 2006
Requires BASS 2.3 - available from www.un4seen.com
See the BASSWMA.CHM file for more complete documentation 
*/

#ifndef BASSWMA_H
#define BASSWMA_H

#use "basswma.lib"

#typedef HWMENCODE UNSIGNED INT 	// WMA encoding handle

// Additional error codes returned by BASS_ErrorGetCode
#define BASS_ERROR_WMA_LICENSE	  1000	// the file is protected
#define BASS_ERROR_WMA			  1001	// Windows Media (9 or above) is not installed
#define BASS_ERROR_WMA_WM9		  BASS_ERROR_WMA
#define BASS_ERROR_WMA_DENIED	  1002	// access denied (user/pass is invalid)
#define BASS_ERROR_WMA_INDIVIDUAL 1004	// individualization is needed

// Additional config options
#define BASS_CONFIG_WMA_PRECHECK	0x10100
#define BASS_CONFIG_WMA_PREBUF		0x10101
#define BASS_CONFIG_WMA_ASX			0x10102

// additional WMA sync type
#define BASS_SYNC_WMA_CHANGE	1001

// additional BASS_StreamGetFilePosition WMA mode
#define BASS_FILEPOS_WMA_BUFFER	1000 // internet buffering progress (0-100%)

// Additional flags for use with BASS_WMA_EncodeOpen/File/Network/Publish
#define BASS_WMA_ENCODE_SCRIPT	0x20000 // set script (mid-stream tags) in the WMA encoding

// Additional flag for use with BASS_WMA_EncodeGetRates
#define BASS_WMA_ENCODE_RATES_VBR	0x10000 // get available VBR quality settings

// WMENCODEPROC "type" values
#define BASS_WMA_ENCODE_HEAD	0
#define BASS_WMA_ENCODE_DATA	1
#define BASS_WMA_ENCODE_DONE	2

// BASS_WMA_EncodeSetTag "type" values
#define BASS_WMA_TAG_ANSI		0
#define BASS_WMA_TAG_UNICODE	1
#define BASS_WMA_TAG_UTF8		2

// BASS_CHANNELINFO type
#define BASS_CTYPE_STREAM_WMA		0x10300
#define BASS_CTYPE_STREAM_WMA_MP3	0x10301

// Additional BASS_ChannelGetTags type
#define BASS_TAG_WMA		8	// WMA tags : array of null-terminated UTF-8 strings


Declare Import, BASS_WMA_StreamCreateFile(INT mem, POINTER *file, INT offset, INT length, INT flags),HSTREAM;
Declare Import, BASS_WMA_StreamCreateFileAuth(INT mem, POINTER *file, INT offset, INT length, INT flags, String user, String pass),HSTREAM;
Declare Import, BASS_WMA_StreamCreateFileUser(INT flags, INT proc, INT user),HSTREAM;

Declare Import, BASS_WMA_EncodeGetRates(INT freq, INT chans, INT flags),UNSIGNED INT;
Declare Import, BASS_WMA_EncodeOpen(INT freq, INT chans, INT flags, INT bitrate, INT proc, INT user),HWMENCODE;
Declare Import, BASS_WMA_EncodeOpenFile(INT freq, INT chans, INT flags, INT bitrate, String file),HWMENCODE;
Declare Import, BASS_WMA_EncodeOpenNetwork(INT freq, INT chans, INT flags, INT bitrate, INT port, INT clients),HWMENCODE;
Declare Import, BASS_WMA_EncodeOpenNetworkMulti(INT freq, INT chans, INT flags, INT bitrates ByRef, INT port, INT clients),HWMENCODE;
Declare Import, BASS_WMA_EncodeOpenPublish(INT freq, INT chans, INT flags, INT bitrate, String url, String user, String pass),HWMENCODE;
Declare Import, BASS_WMA_EncodeOpenPublishMulti(INT freq, INT chans, INT flags, INT bitrates ByRef, String url, String user, String pass),HWMENCODE;
Declare Import, BASS_WMA_EncodeGetPort(INT handle),UNSIGNED INT;
Declare Import, BASS_WMA_EncodeSetNotify(INT handle, INT proc, INT user),INT;
Declare Import, BASS_WMA_EncodeGetClients(INT handle),UNSIGNED INT;
Declare Import, BASS_WMA_EncodeSetTag(INT handle, String tag, String text, INT ttype),INT;
Declare Import, BASS_WMA_EncodeWrite(INT handle, INT buffer, INT length),INT;
Declare Import, BASS_WMA_EncodeClose(INT handle),INT;

Declare Import, BASS_WMA_GetWMObject(INT handle),INT;

//Global Sub CLIENTCONNECTPROC(INT handle, INT connect, INT ip, INT user)
//{
/* Client connection notification callback function.
handle : The encoder
connect: TRUE=client is connecting, FALSE=disconnecting
ip     : The client's IP (xxx.xxx.xxx.xxx:port)
user   : The 'user' parameter value given when calling BASS_EncodeSetNotify */
//}

//Global Sub WMENCODEPROC(INT handle, INT dtype, INT buffer, INT length, INT user)
//{
/* Encoder callback function.
handle : The encoder handle
type   : The type of data, one of BASS_WMA_ENCODE_xxx values
buffer : The encoded data
length : Length of the data
user   : The 'user' parameter value given when calling BASS_WMA_EncodeOpen */
//}

#endif
